let WebSocket;_8a4‍.x([["default",()=>_8a4‍.o]]);_8a4‍.w("ws",[["default",["WebSocket"],function(v){WebSocket=v}]]);

const _8a4‍anonymous=class {

  constructor({port = 8998, clientsPerRoom = 4} = {}) {
    console.log(`WebSocket server on port ${port} is waiting for connection`);
    this.clientsPerRoom = clientsPerRoom;
    this.rooms = new Map();
    this.clientId = 1;
    this.wss = new WebSocket.Server({port});
    this.wss.on('connection', client => {
      const room = this.findOrCreateRoom();
      room.set(client, this.clientId++);
      client.on('message', message => this.broadcast(room, message, client));
      client.on('close', () => {
        room.delete(client);
        this.broadcast(room, {action: 'drop'}, client. false);
        if (room.size == 0) this.rooms.delete(room);
      });
    });
  }

  broadcast(room, message, itself, isJson = true) {
    let cid = room.get(itself);    
    if (isJson) message = JSON.parse(message);
    let data = {message, cid};
    for (let client of room.keys()) {
      if (client !== itself && client.readyState === WebSocket.OPEN) {
        client.send(JSON.stringify(data));
      }
    }
  }

  findOrCreateRoom() {
    let lessPopulatedRoom = null;
    let nbClientsInLessPopulateRoom = this.clientsPerRoom;
    for (let room of this.rooms.keys()) {      
      if (room.size < nbClientsInLessPopulateRoom) {
        nbClientsInLessPopulateRoom = room.size;
        lessPopulatedRoom = room;
      }
    }
    if (lessPopulatedRoom === null) {
      lessPopulatedRoom = new Map();
      this.rooms.set(lessPopulatedRoom, lessPopulatedRoom);
    }
    return lessPopulatedRoom;
  }

};_8a4‍.d(_8a4‍anonymous);