export default class {

  constructor({left = () => 0, right = () => 0, reverse = () => 0, change = () => 0} = {}) {
    this.lastAngle = screen.orientation.angle;
    this.left = left;
    this.right = right;
    this.reverse = reverse;
    this.change = change;
    screen.orientation.addEventListener("change", evt => this.orientationChangeHandler());
  }

  orientationChangeHandler() {        
    let angle = screen.orientation.angle;        
    if ((angle == 270 && this.lastAngle == 0) || (angle == 0 && this.lastAngle == 90)) {
      this.right();
    } else if ((angle == 270 && this.lastAngle == 90) || (angle == 90 && this.lastAngle == 270)) {
      this.reverse();
    } else if ((angle == 90 && this.lastAngle == 0) || (angle == 0 && this.lastAngle == 270)) {
      this.left();
    }        
    if (this.lastAngle != angle) {
      this.change();
    }
    this.lastAngle = angle;
  }

}
