export default (destClass, trait) => {
  Object.assign(destClass.prototype, trait);
  return new Proxy(destClass, {
    construct(target, args) {
      let instance = new target(...args);
      if (typeof trait.construct === "function") {
        trait.construct.call(instance, ...args);
      }
      return instance;
    }
  });
}