import WebSocket from "ws";
import perf from "perf_hooks";

const PING_HIST_SIZE = 5;

export default (option = {}) => {
  const wss = new WebSocket.Server(option);
  wss.on('connection', ws => {
    ws.__pingHist = [];
    ws.__pingHistInd = 0;
    ws.__isAlive = true;
    ws.__latency = 0;
    ws.on('pong', () => {
      ws.__isAlive = true;
      // average latency form actual and past ping
      ws.__pingHist[ws.__pingHistInd] = perf.performance.now() - ws.__pingTime;
      ws.__pingHistInd = (ws.__pingHistInd + 1) % PING_HIST_SIZE;
      let sum = 0;
      for (const latency of ws.__pingHist) sum += latency;
      ws.__latency = sum / ws.__pingHist.length;
    });
  });
  const checkAliveTimer = setInterval(() => {
    wss.clients.forEach(ws => {
      if (!ws.__isAlive) return ws.terminate();
      ws.__isAlive = false;
      ws.__pingTime = perf.performance.now();
      if (ws.readyState === WebSocket.OPEN) ws.ping();
    });
  }, option.checkAlive | 2000);
  wss.on("close", () => clearInterval(checkAliveTimer))
  return wss;
}
