AFRAME.registerComponent('hover-highlighter', {
  schema: {
    color: {type: 'color', default: 'white'}
  },
  init: function () {
    this.el.addEventListener('mouseenter', evt => this.onEnter(evt));
    this.el.addEventListener('mouseleave', evt => this.onLeave(evt));
    this.savedAttr = null;
  },
  onEnter: function (evt) {
    let cursor = evt.detail.cursorEl;
    if (cursor.components['simple-color']) {
      this.savedAttr = {...cursor.getAttribute('simple-color')};
      cursor.setAttribute('simple-color', 'color',  this.data.color);
    }
    if (cursor.components['line']) {
      this.savedAttr = {...cursor.getAttribute('line')};
      cursor.setAttribute('line', 'color',  this.data.color);
    }
  },
  onLeave: function (evt) {
    let cursor = evt.detail.cursorEl;
    if (cursor.components['simple-color']) {
      cursor.setAttribute('simple-color', 'color', this.savedAttr.color);
    }
    if (cursor.components['line']) {
      cursor.setAttribute('line', 'color', this.savedAttr.color);
    }
  },
  remove: function () {
    //this.onLeave();
  }
});

// import {RenderPass, EffectComposer, OutlinePass} from "three-outlinepass"

// AFRAME.registerComponent('hover-highlighter', {
//   schema: {
//     strength: {type: 'number', default: 2.0},
//     glow: {type: 'number', default: 1},
//     color: {type: 'string', default: 'white'}
//   },
//   init: function () {
//     this.el.addEventListener('mouseenter', evt => this.onEnter());
//     this.el.addEventListener('mouseleave', evt => this.onLeave());
//   },
//   onEnter: function () {
//     const scene = this.el.sceneEl.object3D;
//     const camera = this.el.sceneEl.camera;
//     const renderer = this.el.sceneEl.renderer;
//     const render = renderer.render;
//     const composer = new EffectComposer(renderer);
//     let renderPass = new RenderPass(scene, camera);
//     let outlinePass = new OutlinePass(new THREE.Vector2(window.innerWidth, window.innerHeight), scene, camera);
//     composer.addPass(renderPass);
//     composer.addPass(outlinePass);
//     let objects = [];
//     this.el.object3D.traverse(node => {
//       if (!node.isMesh) return;
//       objects.push(node);
//     });
//     outlinePass.selectedObjects = objects;
//     outlinePass.renderToScreen = true;
//     outlinePass.edgeStrength = this.data.strength;
//     outlinePass.edgeGlow = this.data.glow;
//     outlinePass.visibleEdgeColor.set(this.data.color);
//     // HACK the AFRAME render method (a bit ugly)
//     const clock = new THREE.Clock();
//     this.originalRenderMethod = render;
//     let calledByComposer = false;
// 		 renderer.render = function () {
// 		   if (calledByComposer) {
// 		     render.apply(renderer, arguments);
//       } else {
//         calledByComposer = true;
//         composer.render(clock.getDelta());
//         calledByComposer = false;
//      }
//     };
//   },
//   onLeave: function () {
//     this.el.sceneEl.renderer.render = this.originalRenderMethod;
//   },
//   remove: function () {
//     this.onLeave();
//   }
// });

// this.savedEdges = new Map();
// this.el.object3D.traverse(node => {
//   if (!node.isMesh) return;
//   let geometry = new THREE.EdgesGeometry(node.geometry);
//   let material = new THREE.LineBasicMaterial({color: this.data.color});
//   let edges = new THREE.LineSegments(geometry, material);
//   edges.scale.set(1.005, 1.005, 1.005);
//   this.savedEdges.set(node, edges);
//   node.add(edges);
// });
// this.el.object3D.traverse(node => {
//   if (!node.isMesh) return;
//   node.remove(this.savedEdges.get(node));
// });
// this.savedEdges.clear();