import Keyboard from 'utils/keyboard';

AFRAME.registerComponent('movement-extras', {
  dependencies: ['movement-controls'],
  schema: {
    run: {type: 'boolean', default: false},
    runFactor: {type: 'number', default: 2}
  },
  init: function () {
    // if a headset is connected, desactivate mouvement-controls (otherwise activate it)
    const attr = {...this.el.getAttribute('movement-controls')};
    if (this.el.sceneEl.is('vr-mode')) this.disableMovementControls();
    window.addEventListener('enter-vr', e => this.disableMovementControls());
    // implement "shift" run key
    if (this.data.run) {
      const keyboard = new Keyboard();
      keyboard.onKeydown("shift", keys => this.el.setAttribute('movement-controls', {speed: this.data.runFactor * attr.speed}));
      keyboard.onKeyup("shift", keys => this.el.setAttribute('movement-controls', {speed:	attr.speed}));
    }
    //todo: use components disable-vr instead of disabling here
  },
  disableMovementControls: function () {
    let isVr = AFRAME.utils.device.checkHeadsetConnected() || AFRAME.utils.device.isMobile();
    this.el.setAttribute('movement-controls', {enabled: !isVr});
  }
});
