AFRAME.registerComponent('simple-color', {
  schema: {
    color: {type: 'color', default: '#000000'}
  },
  init: function () {
    this.setColor(this.data.color);
  },
  update: function (oldData) {
    if (this.data.color != oldData.color) this.setColor(this.data.color);
  },
  setColor(color) {
    this.el.object3D.traverse(node => {
      if (!node.isMesh) return;
      node.material = new THREE.MeshBasicMaterial({color: new THREE.Color(color)});
    });
  }
});