AFRAME.registerComponent('spawn', {
  schema: {
    pool: {type: 'string'},
    interval: {type: 'int', default: 1000},
    return: {type: 'string', default: "animationcomplete"}
  },
  init: function () {        
    this.scene =  this.el.sceneEl;
    this.pos = this.el.getAttribute("position");    
    this.tick = AFRAME.utils.throttle(this.tick, this.data.interval, this);
    this.returnHandler = evt => {      
      let entity = evt.target;
      entity.removeEventListener(this.data.return, this.returnHandler);  
      this.scene.components[this.data.pool].returnEntity(entity);      
    }
  },
  tick: function () {
    let entity = this.scene.components[this.data.pool].requestEntity();
    if (!entity) return;
    entity.play();      
    entity.object3D.position.set(this.pos.x, this.pos.y, this.pos.z);            
    entity.emit("spawn");
    entity.addEventListener(this.data.return, this.returnHandler);
  }
});